'''Dungeons and Dragons Mod for Source
First Version found @ http://addons.eventscripts.com/addons/view/dnd
Mod Based of Dungeons and Dragons 4.0 System (Pen and Paper)
Preview Info: http://dnd4.com/phb
By: J3ff Hoogland'''
import es, popuplib, random, gamethread, cPickle, os.path, math, langlib, playerlib, gc
info = es.AddonInfo()
info.name = 'Dungeons and Dragons: Source'
info.version = '0.0.8 Python'
info.url = 'http://addons.eventscripts.com/addons/view/dnds'
info.basename = 'dnds'
info.author = 'J3ff Hoogland'
es.ServerVar('D&D',info.version,'Dungeons and Dragons By: J3ff Hoogland').makepublic()
#Debug Blocks
def report(message):
    if int(es.ServerVar('dnds_Debug')):
        if int(es.ServerVar('dnds_Debug')) is 1:
            es.dbgmsg(0, '[Dungeons and Dragons] Debug - %s'%message)
        else:
            es.msg('#multi', '#green[Dungeons and Dragons] Debug - #default%s'%message)
        a = open(es.getAddonPath('dnds') + '/debug.txt','a')
        a.writelines('\n %s' % message)
        es.msg(message)
        a.close()
#Being Events
#Begin Player Events
def player_connect(ev):
    report('%s connected'%ev['name'])
def player_disconnect(ev):
    userid = int(ev['userid'])
    delPlayer(userid)
def player_spawn(ev):
    report('%s spawned'%ev['es_username'])
    userid = int(ev['userid'])
    getPlayer(userid)['Player'].CheckCharacter()
    if not len(getPlayer(userid)['Character'].key['classes']):
        getPlayer(userid)['Menu'].ClassMenu()
        es.changeteam(userid, 1)
        es.tell(userid, '#multi', text('player_spawn 1',{},getPlayer(userid)['playerlib'].get('lang')))
    elif statCheck(userid) is None:
        getPlayer(userid)['Menu'].StatManual()
    elif getPlayer(userid)['Character'].key['race'] is 'Pending':
        getPlayer(userid)['Menu'].RaceMenu()
    elif getPlayer(userid)['Character'].key['unspent level']:
        getPlayer(userid)['Menu'].MultiMenu()
    elif len(getPlayer(self.userid)['Character'].key['stat increase']):
        getPlayer(self.userid)['Menu'].IncreaseStat()
def player_jump(ev):
    userid = int(ev['userid'])
    jump_multiplier = getPlayer(userid)['Player'].key['long jump']
    temp_multiplier = jump_multiplier - 1
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * temp_multiplier for x in range(3)]))
def player_death(ev):
    global Players
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if ev['es_attackerteam'] is not ev['es_userteam']:
        getPlayer(attacker)['Character'].GiveXp(int(es.ServerVar('dnds_KillXp')), text('player_death 1',{'es_username':ev['es_username']},getPlayer(attacker)['playerlib'].get('lang')))
    if Players.has_key(userid):
        for d in Players[userid]['delay list']:
            gamethread.cancelDelayed(d)
        Players[userid]['delay list'] = []
def player_hurt(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if gamedir is not 'cstrike' and gamedir is not 'dod':
        es.event('initialize', 'player_damage')
        es.event('setint','player_damage','userid',userid)
        es.event('setint','player_damage','dmg_health',getPlayer(userid)['Player'].key['health']-int(es.getplayerprop(userid,'CBasePlayer.m_iHealth')))
        es.event('setint','player_damage','attacker',attacker)
        if attacker:
            es.event('setstring','player_damage','weapon',getPlayer(attacker)['playerlib'].get('weapon'))
        else:
            es.event('setstring','player_damage','weapon','world')
        es.event('setint','player_damage','health',int(es.getplayerprop(userid,'CBasePlayer.m_iHealth')))
        es.event('fire','player_damage')
#End Player Events
#Begin global events
def es_map_start(ev):
    es.loadevents('declare', 'addons/eventscripts/dnds/events.res')
def round_end(ev):
    global Players
    winner = int(ev['winner'])
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    Players['delay list'] = []
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
            Players[id]['delay list'] = []
#End global events
#End Events
#Begin Looping Methods
#Our looping method that handel things such as saving and messaging that the mod is running
def LoopBlock():
    for userid in es.getUseridList():
        es.tell(userid, '#multi', text('LoopBlock 1',{},getPlayer(userid)['playerlib'].get('lang')))
    str_path = open(es.getAddonPath('dnds') + '/Characters.db', 'w')
    cPickle.dump(Characters, str_path)
    str_path.close()
    gamethread.delayedname(30, 'dnds loop', LoopBlock)
#Looping block that keep's all user's gravity at the correct amount
def Check():
    for userid in es.getUseridList():
        es.server.queuecmd('es_xfire %s %s %s %s'%(userid, '!self', 'addoutput', '"gravity %s"'%getPlayer(userid)['Player'].key['gravity']))
        getPlayer(userid)['Player'].CheckCharacter()
    gamethread.delayedname(0.5, 'dnds check', Check)
#Loops everytime the server tics (used to player_damage for none CSS/dods games)
def Ticker():
    for id in es.getUseridList():
        getPlayer(id)['Player'].key['health'] = int(es.getplayerprop(id,'CBasePlayer.m_iHealth'))
#End looping methods
#Begin Load Method (And commands)
Players = {'delay list':[]}
Races = {'Dragonborn':{'info':['Dragonborn 1']},
    'Dwarf':{'info':['Dwarf 1']},
    'Eladrin':{'info':['Eladrin 1']},
    'Elf':{'info':['Elf 1']},
    'Half Elf':{'info':['Half Elf 1']},
    'Halfling':{'info':['Halfling 1']},
    'Human':{'info':['Human 1']},
    'Tiefling':{'info':['Tiefling 1']}}
Race_List = ['Dragonborn','Dwarf','Eladrin','Elf','Half Elf','Halfling','Human','Tiefling']
Classes = {'Cleric':{'info':[],
                    'powers1':[]},
    'Fighter':{     'info':[],
                    'powers1':[]},
    'Paladin':{     'info':[],
                    'powers1':[]},
    'Ranger':{      'info':[],
                    'powers1':[]},
    'Rogue':{       'info':[],
                    'powers1':[]},
    'Warlock':{     'info':[],
                    'powers1':[]},
    'Warlord':{     'info':[],
                    'powers1':[]},
    'Wizard':{      'info':[],
                    'powers1':[]}}
Class_List = ['Cleric','Fighter','Paladin','Ranger','Rogue','Warlock','Warlord','Wizard']
Abilities = {'Strength':{'info':[]},
    'Constitution':{'info':[]},
    'Dexterity':{'info':[]},
    'Intelligence':{'info':[]},
    'Wisdom':{'info':[]},
    'Charisma':{'info':[]}}
Ability_List = ['Strength','Constitution','Dexterity','Intelligence','Wisdom','Charisma']
Ability_Increases = [4, 8, 12, 16, 20, 24, 28]
Feats = {'Durable':{'info':[]},
        'Fast Runnner':{'info':[]},
        'Long Jumper':{'info':[]},
        'Power Attack':{'info':[]},
        'Toughness':{'info':[]}}
Feat_List = ['Durable','Fast Runnner','Long Jumper','Power Attack','Toughness']
Feat_Increases = [2, 4, 6, 8, 10, 11, 12, 14, 16, 18, 20, 21, 22, 24, 26, 28, 30]
Characters = {}
#                     Level : Xp Needed to Obtain it
Levels = {2:1000,
    3:2250,
    4:3750,
    5:5500,
    6:7500,
    7:10000,
    8:13000,
    9:16500,
    10:20500,
    11:25500,
    12:31500,
    13:38500,
    14:46500,
    15:56500,
    16:68500,
    17:82500,
    18:98500,
    19:118500,
    20:142500,
    21:170500,
    22:202500,
    23:244000,
    24:295000,
    25:355500,
    26:425500,
    27:515500,
    28:625500,
    29:755500,
    30:905500}
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - Begin Load')
    global text, Characters, gamedir, game
    text = langlib.Strings(es.getAddonPath('dnds') + '/strings.ini')
    str_path = es.getAddonPath('dnds') + '/Characters.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        Characters = cPickle.load(file_users)
        file_users.close()
    gamedir = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[~0]
    if gamedir == 'cstrike':
        game = 'Counter-Strike: Source'
    elif gamedir == 'hl2mp':
        game = 'Half Life 2 Deathmatch'
    elif gamedir == 'dod':
        game = 'Day of Defeat: Source'
    elif gamedir == 'pvkii':
        game = 'Pirates, Vikings, and Knights'
    elif gamedir == 'tf':
        game = 'Team Fortress 2'
    else:
        game = 'Unknown'
        es.dbgmsg(0, '[Dungeons and Dragons] - Game is Unkown - Request support for this game @ http://featurelist.org/dnds')
    es.dbgmsg(0, '[Dungeons and Dragons] - Directory %s'%gamedir)
    if game is not 'Unknown':
        es.dbgmsg(0, '[Dungeons and Dragons] - Game %s'%game)
        es.load('dnds/games/%sdnds'%gamedir)
    if not es.exists('saycommand', 'dnd'):
        es.regsaycmd('dnd', 'dnds/Command')
    if not es.exists('clientcommand', 'dnd'):
        es.regclientcmd('dnd', 'dnds/Command')
    ServerVars = {'dnds_KillXp':60,
                    'dnds_Debug':0}
    for x in ServerVars:
        es.ServerVar(x).set(ServerVars[x])
    if os.path.isfile(es.getAddonPath('dnds')+'/dnds.cfg'):
        es.server.queuecmd('es_xmexec ../addons/eventscripts/dnds/dnds.cfg')
    else:
        es.dbgmsg(0, '[Dungeons and Dragons] - Cannot find the dnds.cfg file! - Using default values...')
    LoopBlock()
    Check()
    es.loadevents('declare', 'addons/eventscripts/dnds/events.res')
    if gamedir is not 'cstrike' and gamedir is not 'dod':
        es.addons.registerTickListener(Ticker)
    es.dbgmsg(0, '[Dungeons and Dragons] - Load Finished')
#End Load Methods
#Begin unload methods
def unload():
    es.dbgmsg(0, '[Dungeons and Dragons] - Unload Start')
    if gamedir is not 'cstrike' and gamedir is not 'dod':
        es.addons.unregisterTickListener(Ticker)
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
    for d in ['dnds loop', 'dnds check']:
        gamethread.cancelDelayed(d)
    es.unload('dnds/games/%sdnds'%gamedir)
    es.dbgmsg(0, '[Dungeons and Dragons] - Unload End')
#end unload methods
#Begin global methods
#Returns the ability mod of a given score value
def statMod(value):
    return (value-10)/2
#Checks to see if any of a user's ability scores are 0
def statCheck(userid):
    abilities = getPlayer(userid)['Character'].key['abilities']
    for a in Ability_List:
        if not abilities[a]:
            return None
            break
    return 1
#Used to handle all acessing of classes (Menu, Character, and Player)
__Players = {}
def getPlayer(userid):
    #report('%s is running through the getPlayer block'%es.getplayername(userid))
    userid = int(userid)
    global __Players
    if not __Players.has_key(userid):
        report('Creating a user key for %s for the 3 global classes'%es.getplayername(userid))
        __Players[userid] = {'Player':Player(userid),'Menu':Menu(userid),'Character':Character(userid),'playerlib':playerlib.getPlayer(userid)}
    else:
        if Players[userid]['character']:
            __Players[userid]['Character'].key = Characters[Players[userid]['character']]
    return __Players[userid]
def delPlayer(userid):
    userid = int(userid)
    #global __Players
    if __Players.has_key(userid):
        del __Players[userid]
        gc.collect()
#End global methods
#Begin Classes
#Our menu class, handels all static and dynamic menus
class Menu(object):
    def __init__(self, userid):
        report('Start Menu init')
        self.userid = int(userid)
        report('End Menu init')
    def Unsend(self):
        if not es.isbot(self.userid):
            count = popuplib.active(self.userid)['count']
            #es.msg(popuplib.active(self.userid))
            while count > 0:
                count -= 1
                if popuplib.active(self.userid)['name'] is not '0':
                    popuplib.close(popuplib.active(self.userid)['name'], self.userid)
    def MainMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        MMenu = popuplib.create('MMenu')
        for i in range(1, 8):
            MMenu.addline(text('MainMenu %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        MMenu.menuselect = self.MainMenuSelect
        MMenu.send(self.userid)
    def MainMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            if getPlayer(self.userid)['playerlib'].get('isdead'):
                es.tell(self.userid, '#multi', text('MainMenuSelect 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
                es.escinputbox(10, self.userid, text('MainMenuSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')), text('MainMenuSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')), 'dnd create')
            else:
                es.tell(self.userid, '#multi', text('MainMenuSelect 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
        elif choice == 2:
            getPlayer(self.userid)['Player'].CharacterMenu()
        elif choice == 3:
            self.CharacterInformation()
        elif choice == 6:
            self.InfoMenu()
        elif choice == 7:
            self.HelpMenu()
    def CharacterInformation(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        statsmenu = popuplib.create('statsmenu')
        statsmenu.addline(text('CharacterInformation 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 2',{'character':getPlayer(self.userid)['Player'].key['character']},getPlayer(self.userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 3',{'xp':getPlayer(self.userid)['Character'].key['xp']},getPlayer(self.userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 4',{'race':getPlayer(self.userid)['Character'].key['race']},getPlayer(self.userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 5',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for c in sorted(getPlayer(self.userid)['Character'].key['classes'].keys()):
            statsmenu.addline(' - %s (Level %s)'%(c, getPlayer(self.userid)['Character'].key['classes'][c]['level']))
        statsmenu.addline('Abilities:')
        abilities = getPlayer(self.userid)['Character'].key['abilities']
        for a in Ability_List:
            statsmenu.addline(' - %s (%s)'%(a, abilities[a]))
        statsmenu.addline(text('CharacterInformation 6',{},getPlayer(self.userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 7',{},getPlayer(self.userid)['playerlib'].get('lang')))
        statsmenu.menuselect = self.CISelect
        statsmenu.send(self.userid)
    def CISelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.MainMenu()
    def HelpMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        welcomemenu = popuplib.create('welcomemenu')
        for i in range(1, 11):
            welcomemenu.addline(text('HelpMenu %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        welcomemenu.menuselect = self.MainMenu
        welcomemenu.send(self.userid)
    def InfoMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        infomenu = popuplib.create('infomenu')
        for i in range(1, 10):
            infomenu.addline(text('InfoMenu %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        infomenu.menuselect = self.InfoSelect
        infomenu.send(self.userid)
    def InfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.MainMenu()
        elif choice == 8:
            self.ModInfo()
        elif choice == 7:
            self.GeneralInfo()
        elif choice == 4:
            self.FeatInfo()
        elif choice == 3:
            self.StatInfo()
        elif choice == 2:
            self.ClassInfo()
        elif choice == 1:
            self.RaceInfo()
    def FeatInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        fmenu = popuplib.easymenu('fmenu',None,self.FeatInfoSelect)
        fmenu.settitle(text('FeatInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for f in Feat_List:
            fmenu.addoption(f, f)
        if 'unspent' in getPlayer(self.userid)['Character'].key['feats']:
            fmenu.addoption('pick', text('FeatInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        fmenu.addoption('back', text('FeatInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        fmenu.send(self.userid)
    def FeatInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'pick':
            self.FeatMenu()
        elif choice == 'back':
            self.InfoMenu()
        else:
            finfo = popuplib.create('finfo')
            finfo.addline(text('FeatInfoSelect 1',{'feat':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Feats[choice]['info']:
                finfo.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            finfo.addline(text('FeatInfoSelect 2',{'feat':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            finfo.addline(text('FeatInfoSelect 3',{'feat':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            finfo.menuselect = self.FeatInfoChoiceSelect
            finfo.send(self.userid)
    def FeatInfoChoiceSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.FeatInfo()
    def ModInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        modinfo = popuplib.create('modinfo')
        for i in range(1, 8):
            infomenu.addline(text('ModInfo %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        modinfo.menuselect = self.ModInfoSelect
        modinfo.send(self.userid)
    def ModInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.InfoMenu()
    def GeneralInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        geninfo = popuplib.create('geninfo')
        for i in range(1, 5):
            geninfo.addline(text('GeneralInfo %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        geninfo.menuselect = self.GeneralInfoSelect
        geninfo.send(self.userid)
    def GeneralInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.InfoMenu()
        elif choice == 1:
            self.CustomCommands()
    def CustomCommands(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        ccinfo = popuplib.create('ccinfo')
        for i in range(1, 7):
            ccinfo.addline(text('CustomCommands %s'%i,{},getPlayer(self.userid)['playerlib'].get('lang')))
        ccinfo.menuselect = self.CustomCommandsSelect
        ccinfo.send(self.userid)
    def CustomCommandsSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.GeneralInfo()
    def StatInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        SMenu = popuplib.easymenu('stat info', None, self.StatInfoSelect)
        SMenu.settitle(text('StatInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for stat in Ability_List:
            SMenu.addoption(stat, stat)
        if getPlayer(self.userid)['Player'].key['pending'] == 'Stat':
            SMenu.addoption('pick', text('StatInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            SMenu.addoption('back', text('StatInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        SMenu.send(self.userid)
    def StatInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'back':
            self.InfoMenu()
        elif choice == 'pick':
            self.StatMenu()
        else:
            infomenu = popuplib.create('%s info'%choice)
            infomenu.addline(text('StatInfoSelect 1',{'choice':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Abilities[choice]['info']:
                infomenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('StatInfoSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('StatInfoSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.menuselect = self.InfoStatSelect
            infomenu.send(self.userid)
        getPlayer(self.userid)['Player'].key['pending'] = None
    def InfoStatSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.StatInfo()
    def StatMenu(self, userid=None, choice=None, popupid=None):
        report('running unsend')
        self.Unsend()
        report('building stats popup')
        statmenu = popuplib.create('stats')
        statmenu.addline('How would you like to assign your ability points:')
        statmenu.addline('-> 1. Automatically')
        statmenu.addline('-> 2. Manually')
        statmenu.addline('-> 3. Ability Information')
        report('assigning menuselect for stats')
        statmenu.menuselect = self.StatSelect
        report('sending stats popup')
        statmenu.send(self.userid)
    def StatSelect(self, userid=None, choice=None, popupid=None):
        if choice == 3:
            getPlayer(self.userid)['Player'].key['pending'] = 'Stat'
            self.StatInfo()
        elif choice == 2:
            self.StatManual()
        elif choice == 1:
            classes = getPlayer(self.userid)['Character'].key['classes'].keys()
            if 'Cleric' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':11,
                                        'Intelligence':10,
                                        'Wisdom':16,
                                        'Charisma':13}
            elif 'Fighter' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':14,
                                        'Constitution':16,
                                        'Dexterity':13,
                                        'Intelligence':10,
                                        'Wisdom':12,
                                        'Charisma':11}
            elif 'Paladin' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':16,
                                        'Constitution':14,
                                        'Dexterity':11,
                                        'Intelligence':10,
                                        'Wisdom':12,
                                        'Charisma':13}
            elif 'Ranger' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':16,
                                        'Intelligence':11,
                                        'Wisdom':13,
                                        'Charisma':10}
            elif 'Rogue' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':12,
                                        'Constitution':13,
                                        'Dexterity':16,
                                        'Intelligence':14,
                                        'Wisdom':11,
                                        'Charisma':10}
            elif 'Warlock' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':11,
                                        'Constitution':16,
                                        'Dexterity':12,
                                        'Intelligence':14,
                                        'Wisdom':10,
                                        'Charisma':13}
            elif 'Warlord' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':16,
                                        'Constitution':12,
                                        'Dexterity':11,
                                        'Intelligence':13,
                                        'Wisdom':10,
                                        'Charisma':14}
            elif 'Wizard' in classes:
                getPlayer(self.userid)['Character'].key['abilities'] = {'Strength':10,
                                        'Constitution':14,
                                        'Dexterity':13,
                                        'Intelligence':16,
                                        'Wisdom':12,
                                        'Charisma':11}
            else:
                self.ClassMenu()
            if len(classes):
                self.RaceMenu()
        else:
            self.StatMenu()
    def StatManual(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        AMenu = popuplib.easymenu('atmenu', None, self.StatManualSelect)
        abilities = getPlayer(self.userid)['Character'].key['abilities']
        count = 0
        for a in Ability_List:
            if not abilities[a]:
                count += 1
                AMenu.addoption(a, a)
        key = {6:16,5:14,4:13,3:12,2:11,1:10}
        if count:
            AMenu.settitle('Select a stat to set to %s'%key[count])
            getPlayer(self.userid)['Player'].key['pending'] = key[count]
            AMenu.send(self.userid)
        else:
            self.RaceMenu()
    def StatManualSelect(self, userid=None, choice=None, popupid=None):
        getPlayer(self.userid)['Character'].key['abilities'][choice] = getPlayer(self.userid)['Player'].key['pending']
        self.StatManual()
    def RaceMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        RMenu = popuplib.easymenu('race menu', None, self.RaceSelect)
        RMenu.settitle(text('RaceMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for race in Race_List:
            RMenu.addoption(race, race)
        RMenu.addoption('info', text('RaceMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        RMenu.send(self.userid)
    def RaceSelect(self, userid=None, choice=None, popupid=None):
        if choice != 'info':
            getPlayer(self.userid)['Character'].key['race'] = choice
            es.tell(self.userid, '#multi', text('RaceSelect 1',{'race':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            abilities = getPlayer(self.userid)['Character'].key['abilities']
            if choice == 'Dragonborn':
                abilities['Strength'] += 2
                abilities['Charisma'] += 2
            elif choice == 'Dwarf':
                abilities['Constitution'] += 2
                abilities['Wisdom'] += 2
            elif choice == 'Eladrin':
                abilities['Dexterity'] += 2
                abilities['Intelligence'] += 2
            elif choice == 'Elf':
                abilities['Dexterity'] += 2
                abilities['Wisdom'] += 2
            elif choice == 'Half Elf':
                abilities['Constitution'] += 2
                abilities['Charisma'] += 2
            elif choice == 'Halfling':
                abilities['Dexterity'] += 2
                abilities['Charisma'] += 2
            elif choice == 'Human':
                getPlayer(self.userid)['Character'].key['stat increase'].append([2, text('RaceSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang'))])
                self.IncreaseStat()
            elif choice == 'Tiefling':
                abilities['Intelligence'] += 2
                abilities['Charisma'] += 2
            self.FeatMenu()
        else:
            self.RaceInfo()
    def FeatMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        if 'unspent' in getPlayer(self.userid)['Character'].key['feats']:
            fmenu = popuplib.easymenu('fmenu',None,self.FeatMenuSelect)
            fmenu.settitle(text('FeatMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
            for f in Feat_List:
                fmenu.addoption(f, f)
            fmenu.addoption('info',text('FeatMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            fmenu.send(self.userid)
    def FeatMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice is 'info':
            self.FeatInfo()
        else:
            getPlayer(self.userid)['Character'].key['feats'].remove('unspent')
            getPlayer(self.userid)['Character'].key['feats'].append(choice)
            es.tell(self.userid, '#multi',text('FeatMenuSelect 1',{'feat':choice},getPlayer(self.userid)['playerlib'].get('lang')) )
            self.FeatMenu()
    def IncreaseStat(self, userid=None, choice=None, popupid=None):
        if len(getPlayer(self.userid)['Character'].key['stat increase']):
            self.Unsend()
            si = getPlayer(self.userid)['Character'].key['stat increase'][0]
            abilities = getPlayer(self.userid)['Character'].key['abilities']
            AMenu = popuplib.easymenu('amenu', None, self.IncreaseStatSelect)
            AMenu.settitle(text('IncreaseStat 1',{'amount':si[0],'reason':si[1]},getPlayer(self.userid)['playerlib'].get('lang')))
            for a in Ability_List:
                AMenu.addoption((a,si[0]), '%s (%s)'%(a,abilities[a]))
            AMenu.send(self.userid)
    def IncreaseStatSelect(self, userid=None, choice=None, popupid=None):
        getPlayer(self.userid)['Character'].key['abilities'][choice[0]] += choice[1]
        es.tell(self.userid, '#multi', text('IncreaseStatSelect 1',{'stat':choice[0],'value':getPlayer(self.userid)['Character'].key['abilities'][choice[0]]},getPlayer(self.userid)['playerlib'].get('lang')))
        getPlayer(self.userid)['Character'].key['stat increase'].remove(getPlayer(self.userid)['Character'].key['stat increase'][0])
        self.IncreaseStat()
    def RaceInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        RMenu = popuplib.easymenu('race info', None, self.RaceInfoSelect)
        RMenu.settitle(text('RaceInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for race in Race_List:
            RMenu.addoption(race, race)
        if getPlayer(self.userid)['Character'].key['race'] is 'Pending':
            RMenu.addoption('pick', text('RaceInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            RMenu.addoption('back', text('RaceInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        RMenu.send(self.userid)
    def RaceInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'pick':
            self.RaceMenu()
        elif choice == 'back':
            self.InfoMenu()
        else:
            infomenu = popuplib.create('%s info'%choice)
            infomenu.addline(text('RaceInfoSelect 1',{'choice':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Races[choice]['info']:
                infomenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            if getPlayer(self.userid)['Character'].key['race'] is 'Pending':
                getPlayer(self.userid)['Player'].key['pending'] = choice
                infomenu.addline(text('RaceInfoSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('RaceInfoSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('RaceInfoSelect 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.menuselect = self.InfoRaceSelect
            infomenu.send(self.userid)
    def InfoRaceSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8 and getPlayer(self.userid)['Player'].key['pending'] and getPlayer(self.userid)['Character'].key['race'] is 'Pending':
            self.RaceSelect(choice=getPlayer(self.userid)['Player'].key['pending'])
        elif choice == 9:
            self.RaceInfo()
        getPlayer(self.userid)['Player'].key['pending'] = None
    def ClassMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        CMenu = popuplib.easymenu('Class menu', None, self.ClassSelect)
        CMenu.settitle(text('ClassMenu 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for Class in Class_List:
            CMenu.addoption(Class, Class)
        CMenu.addoption('info', text('ClassMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        CMenu.send(self.userid)
    def ClassSelect(self, userid=None, choice=None, popupid=None):
        if choice != 'info':
            report('sending statmenu')
            self.StatMenu()
            report('setting %s to level 1'%choice)
            getPlayer(self.userid)['Character'].key['classes'][choice] = {'level':1}
            report('sending classselect message')
            es.tell(self.userid, '#multi', text('ClassSelect 1',{'class':choice},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            self.ClassInfo()
    def ClassInfo(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        CMenu = popuplib.easymenu('Class info', None, self.ClassInfoSelect)
        CMenu.settitle(text('ClassInfo 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        for Class in Class_List:
            CMenu.addoption(Class, Class)
        if not getPlayer(self.userid)['Character'].key['classes']:
            CMenu.addoption('pick', text('ClassInfo 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            CMenu.addoption('back', text('ClassInfo 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        CMenu.send(self.userid)
    def ClassInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'pick':
            self.ClassMenu()
        elif choice == 'back':
            self.InfoMenu()
        else:
            infomenu = popuplib.create('%s info'%choice)
            infomenu.addline(text('ClassInfoSelect 1',{'choice':choice},getPlayer(self.userid)['playerlib'].get('lang')))
            for line in Classes[choice]['info']:
                infomenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
            if not getPlayer(self.userid)['Character'].key['classes']:
                infomenu.addline(text('ClassInfoSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            getPlayer(self.userid)['Player'].key['pending'] = choice
            infomenu.addline(text('ClassInfoSelect 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.addline(text('ClassInfoSelect 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
            infomenu.menuselect = self.InfoClassSelect
            infomenu.send(self.userid)
    def InfoClassSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8 and not getPlayer(self.userid)['Character'].key['classes']:
            self.ClassSelect(choice=getPlayer(self.userid)['Player'].key['pending'])
        elif choice == 9:
            self.ClassInfo()
        elif choice == 1:
            self.Powers1Info()
        if choice != 1:
            getPlayer(self.userid)['Player'].key['pending'] = None
    def Powers1Info(self, userid=None, choice=None, popupid=None):
        Class = getPlayer(self.userid)['Player'].key['pending']
        imenu = popuplib.create('imenu')
        imenu.addline(text('Powers1Info 1',{'class':Class},getPlayer(self.userid)['playerlib'].get('lang')))
        for line in Classes[Class]['powers1']:
            imenu.addline(text(line,{},getPlayer(self.userid)['playerlib'].get('lang')))
        imenu.addline(text('Powers1Info 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
        imenu.addline(text('Powers1Info 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
        imenu.menuselect = self.Powers1InfoSelect
    def Powers1InfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9:
            self.ClassInfoSelect(choice=getPlayer(self.userid)['Player'].key['pending'])
        else:
            getPlayer(self.userid)['Player'].key['pending'] = None
    def MultiMenu(self, userid=None, choice=None, popupid=None):
        self.Unsend()
        UserKey = getPlayer(self.userid)['Character'].key
        classes = UserKey['classes'].keys()
        if len(UserKey['classes']) is 2:
            if classes[1] < classes[0]:
                up = 1
            else:
                up = 0
            UserKey['classes'][classes[up]] += 1
            es.tell(self.userid, '#multi', text('MultiMenu 1',{'class':classes[up],'level':UserKey['classes'][classes[up]]},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            clas = UserKey['classes'][classes[up]].keys()[0]
            CMenu.popuplib.easymenu('cmenu',None,self.MultiMenuSelect)
            CMenu.settitle(text('MultiMenu 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
            CMenu.addoption('cur', text('MultiMenu 3',{'class':clas},getPlayer(self.userid)['playerlib'].get('lang')))
            for x in Class_List:
                if x is not clas:
                    CMenu.addoption(x, x)
            CMenu.send(self.userid)
    def MultiMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'cur':
            for x in self.key['classes']:
                getPlayer(self.userid)['Character'].GiveLevel(1, x)
                es.tell(self.userid, '#multi', text('MultiMenuSelect 1',{'class':x},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            getPlayer(self.userid)['Character'].key['classes'][choice] = 1
            getPlayer(self.userid)['Character'].GiveLevel(1)
            es.tell(self.userid, '#multi', text('MultiMenuSelect 2',{'class':choice},getPlayer(self.userid)['playerlib'].get('lang')))
        getPlayer(self.userid)['Character'].key['unspent level'] -= 1
#Begin Player Class
class Player(object):
    global Players
    def __init__(self, userid):
        report('Start player init')
        self.userid = int(userid)
        self.steamid = es.getplayersteamid(self.userid)
        if not Players.has_key(self.userid):
            Players[self.userid] = {}
            Players[self.userid]['character'] = None
            Players[self.userid]['pending'] = None
            Players[self.userid]['characters list'] = []
            Players[self.userid]['delay list'] = []
            Players[self.userid]['gravity'] = 1.0
            Players[self.userid]['freeze'] = 0
            Players[self.userid]['long jump'] = 1.0
        self.key = Players[self.userid]
        report('End player init')
    def CheckCharacter(self):
        for x in Characters:
            if Characters[x]['creator'] == self.steamid:
                if not self.key['character']:
                    self.key['character'] = x
                if x not in self.key['characters list']:
                    self.key['characters list'].append(x)
        if not self.key['character']:
            getPlayer(self.userid)['Character'].Setup(es.getplayername(self.userid), 1)
    def AddCharacter(self, Name):
        self.key['characters list'].append(Name)
        self.key['character'] = Name
    def SetCharacter(self, Name):
        if Characters.has_key(Name):
            if not self.LoopCharacter(Name):
                self.key['character'] = Name
                es.tell(self.userid, '#multi', text('SetCharacter 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
            else:
                es.tell(self.userid, '#multi', text('SetCharacter 2',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            es.tell(self.userid, '#multi', text('SetCharacter 3',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def LoopCharacter(self, Name):
        for x in es.getUseridList():
            if Players[x]['character'] == Name:
                return 1
        return 0
    def TempCharacter(self, Name):
        if Characters.has_key(Name):
            if Characters[Name]['password'] != 'locked':
                self.key['pending'] = Name
                es.tell(self.userid, '#multi', text('TempCharacter 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
                es.escinputbox(10, self.userid, text('TempCharacter 2',{},getPlayer(self.userid)['playerlib'].get('lang')), text('TempCharacter 3',{},getPlayer(self.userid)['playerlib'].get('lang')), 'dnd passwordenter')
            else:
                es.tell(self.userid, '#multi', text('TempCharacter 3',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            es.tell(self.userid, '#multi', text('TempCharacter 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def PasswordEnter(self, Password):
        if self.key['pending']:
            if Password == Characters[self.key['pending']]['password']:
                self.SetCharacter(self.key['pending'])
            else:
                es.tell(self.userid, '#multi', text('PasswordEnter 1',{'password':Password,'pending':self.key['pending']},getPlayer(self.userid)['playerlib'].get('lang')))
            self.key['pending'] = None
        else:
            es.tell(self.userid, '#multi', text('PasswordEnter 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def CharacterMenu(self):
        CMenu = popuplib.easymenu('CMenu', '_popup_choice', self.CharacterMenuSelect)
        CMenu.settitle(text('CharacterMenu 1',{'name':es.getplayername(self.userid)},getPlayer(self.userid)['playerlib'].get('lang')))
        for x in self.key['characters list']:
            CMenu.addoption(x, x)
        CMenu.send(self.userid)
    def CharacterMenuSelect(self, userid, choice, popupid):
        es.sexec(self.userid, 'dnd load %s'%choice)
    def Delayed(self, duration, function, parama=(), Endround=None):
        if not Endround:
            gamethread.delayedname(duration, len(self.key['delay list'])+1, function, parama)
            self.key['delay list'].append(len(self.key['delay list'])+1)
        else:
            gamethread.delayedname(duration, len(Players['delay list'])+1, function, parama)
            Players['delay list'].append(len(Players['delay list'])+1)
    def Freeze(self, duration=None):
        self.key['freeze'] += 1
        es.server.queuecmd('est_freeze %s 1'%self.userid)
        if duration:
            gamethread.delayed(duration, self.Unfreeze)
    def Unfreeze(self):
        self.key['freeze'] -= 1
        if not self.key['freeze']:
            es.server.queuecmd('est_freeze %s 0'%self.userid)
    def Damage(self, damage, attacker):
        Health = int(es.getplayerprop('CBasePlayer.m_iHealth'))
        if Health <= damage:
            es.server.queuecmd('est_damage %s %s %s'%(self.userid, damage, attacker))
        else:
            es.setplayerprop('CBasePlayer.m_iHealth', Health-damage)
#End Player Class
#Begin Character Class
class Character(object):
    global Characters
    def __init__(self, userid=None):
        report('Character init start')
        self.userid = int(userid)
        self.steamid = es.getplayersteamid(self.userid)
        if Players[self.userid]['character']:
            self.key = Characters[Players[self.userid]['character']]
            self.character = Players[self.userid]['character']
        else:
            self.key = None
            self.character = None
        report('Character init end')
    def Setup(self, Name, Forced=None):
        if not Characters.has_key(Name):
            if getPlayer(self.userid)['playerlib'].get('isdead') or int(es.getplayerteam(self.userid)) == 1:
                self.Create(Name)
            elif Forced:
                self.Create(Name)
            else:
                es.tell(self.userid, '#multi', text('Setup 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        elif Forced:
            self.Setup('%sX'%Name, 1)
        else:
            es.tell(self.userid, '#multi', text('Setup 2',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def Create(self, Name):
        Characters[Name] = {}
        Characters[Name]['creator'] = self.steamid
        Characters[Name]['race'] = 'Pending'
        Characters[Name]['classes'] = {}
        Characters[Name]['feats'] = ['unspent']
        Characters[Name]['abilities'] = {'Strength':None,
                                        'Constitution':None,
                                        'Dexterity':None,
                                        'Intelligence':None,
                                        'Wisdom':None,
                                        'Charisma':None}
        Characters[Name]['password'] = 'locked'
        Characters[Name]['xp'] = 0
        Characters[Name]['level'] = 1
        Characters[Name]['unspent level'] = 0
        Characters[Name]['stat increase'] = []
        getPlayer(self.userid)['Player'].AddCharacter(Name)
        getPlayer(self.userid)['Menu'].ClassMenu()
        self.key = Characters[Name]
        self.character = Name
        es.tell(self.userid, '#multi', text('Create 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def SetPassword(self, Password):
        Characters[Players[self.userid]['character']]['password'] = Password
        es.tell(self.userid, '#multi', text('SetPassword',{'character':Players[self.userid]['character'],'password':Password},getPlayer(self.userid)['playerlib'].get('lang')))
    def GiveXp(self, amount, reason):
        if self.key['xp'] < Levels[30]:
            self.key['xp'] += amount
            if self.key['xp'] >= Levels[self.key['level']+1]:
                self.key['level'] += 1
                if len(self.key['classes']) is 1 and self.key['level'] is not 10 and self.key['level'] is not 20:
                    for x in self.key['classes']:
                        self.GiveLevel(1, x)
                else:
                    Characters[getPlayer(self.userid)['Player'].key['character']]['unspent level'] += 1
                    getPlayer(self.userid)['Menu'].MultiMenu()
                es.tell(self.userid, '#multi', text('GiveXp 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang')))
            else:
                es.tell(self.userid, '#multi', text('GiveXp 2',{'amount':amount,'reason':reason},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            self.key['xp'] = Levels[30]
    def GiveLevel(self, amount, Class=None):
        if Class:
            self.key['classes'][Class]['level'] += amount
        self.key['level'] += amount
        if self.key['level'] in Ability_Increases:
            getPlayer(self.userid)['Character'].key['stat increase'].append([1, text('GiveLevel 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang'))])
            getPlayer(self.userid)['Character'].key['stat increase'].append([1, text('GiveLevel 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang'))])
        if self.key['level'] in [11, 21]:
            for a in Ability_List:
                self.key['abilities'][x] += 1
            es.tell(self.userid, '#multi', text('GiveLevel 2',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang')))
        if self.key['level'] in Feat_Increases:
            self.key['feats'].append('unspent')
#End Classes
#Begin handels for our 'dnd' command that can be run in client console/chat
def Command():
    userid = int(es.getcmduserid())
    steamid = es.getplayersteamid(userid)
    player = getPlayer(userid)['playerlib']
    arg1 = es.getargv(1).lower()
    argcount = es.getargc()
    stringcount = 2
    commandstring = ''
    while stringcount < argcount:
        addstring = es.getargv(stringcount)
        if commandstring:
            commandstring = '%s %s'%(commandstring, addstring)
        else:
            commandstring = addstring
        stringcount += 1
    if arg1 == 'create':
        getPlayer(userid)['Character'].Setup(commandstring)
    elif arg1 == 'load':
        if player.get('isdead') or int(es.getplayerteam(userid)) == 1:
            if Characters.has_key(commandstring):
                if Characters[commandstring]['password'] == 'locked' and Characters[commandstring]['creator'] == steamid:
                    getPlayer(userid)['Player'].SetCharacter(commandstring)
                else:
                    getPlayer(userid)['Player'].TempCharacter(commandstring)
            else:
                es.tell(userid, '#multi', text('Command 1',{'commandstring':commandstring},getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', text('Command 2',{},player.get('lang')))
    elif arg1 == 'passwordenter':
        getPlayer(userid)['Player'].PasswordEnter(commandstring)
    elif arg1 == 'passwordset':
        getPlayer(userid)['Character'].SetPassword(commandstring)
    elif arg1 == 'loadmenu':
        getPlayer(userid)['Player'].CharacterMenu()
    elif arg1 == 'menu' or arg1 == 'mainmenu':
        getPlayer(userid)['Menu'].MainMenu()
    elif arg1 == 'stats':
        getPlayer(userid)['Menu'].CharacterInformation()
    elif arg1 == 'help' or arg1 == '':
        getPlayer(userid)['Menu'].HelpMenu()
    elif arg1 == 'info':
        getPlayer(userid)['Menu'].InfoMenu()
    else:
        es.tell(userid, '#multi', text('Command 3',{'commandstring':commandstring},getPlayer(userid)['playerlib'].get('lang')))
#End Character Class
#End our command handels